## Extended algorithm
### Setup
#### 1. Running
To run this program compile and run `ScenarioSolver.java` as standard java program. Program automatically runs algorithm multiple times with different parameters as  defined in `parameters.json`.
#### 2. Input
Program input parameters are defined in `resources/parameters.json` file with following properties

```json 
{
   "factorStart": 0.1, // initial perturbation intensity 
   "factorEnd": 0.5, // final perturbation intensity
   "factorStep": 0.1, // perturbation intensity step
   "chanceStart": 0.1, // initial perturbation probability
   "chanceEnd": 0.5, // final perturbation probability
   "chanceStep": 0.1, // perturbation probability step
   "nodes": 20, // number of nodes in given input
   "areaOrIterations": 100, // local search size
   "type": "LOCAL_SEARCH", // mode
   "logLevel": "DEBUG", // log level
   "append": false // append to output or overwrite
 }
```

Program input is expected in folder `resources/input_interval_<number_of_nodes>` as separate file for each input graph
<br/>
 There are default examples in `resources/input_interval_20` folder.
 #### 3. Output
 Output will be written in file `resources/output_scenario_solver/results_<nodes>_<area>_area.csv` where nodes and area variables are number of nodes in graph and size of local search.