package hr.pmf.aklobucar.extended.scenariosolver;

import java.util.Arrays;
import java.util.stream.Collectors;
import java.util.stream.Stream;

public class AverageScenarioSolution {

    public  AverageScenarioSolution() {

    }

    public static String getHeaders() {
        return String.join(",", Arrays.asList(
                "Nodes",
                "Children",
                "Maximum weight",
                "Mutation chance",
                "Mutation factor",
                "Area search size",
                "Average regret improvement (%)",
                "Average initial regret",
                "Average final regret",
                "Average initial regret time (µs)",
                "Average area search time (µs)",
                "Average total time (µs)",
                "Average slowdown")) + "\n";
    }

    public String getCsv() {
        return Stream.of(
                this.nodes,
                this.children,
                this.maxWeight,
                this.mutationChance,
                this.mutationFactor,
                this.areaOrIterations,
                this.averageImprovement,
                this.averageInitialRegret,
                this.averageFinalRegret,
                this.averageInitialRegretTime,
                this.averageLocalSearchTime,
                this.averageTotalTime,
                this.averageSlowdown).map(item -> item + "").collect(Collectors.joining(",")) + "\n";
    }

    public AverageScenarioSolution(int nodes, int children, int maxWeight, double mutationChance, double mutationFactor, int areaOrIterations,
                                   double averageInitialRegret, double averageInitialRegretTime, double averageFinalRegret,
                                   double averageImprovement, double averageLocalSearchTime, double averageTotalTime, double averageSlowdown) {
        this.nodes = nodes;
        this.children = children;
        this.maxWeight = maxWeight;
        this.mutationChance = mutationChance;
        this.mutationFactor = mutationFactor;
        this.areaOrIterations = areaOrIterations;
        this.averageInitialRegret = averageInitialRegret;
        this.averageInitialRegretTime = averageInitialRegretTime;
        this.averageFinalRegret = averageFinalRegret;
        this.averageImprovement = averageImprovement;
        this.averageLocalSearchTime = averageLocalSearchTime;
        this.averageTotalTime = averageTotalTime;
        this.averageSlowdown = averageSlowdown;
    }

    public int nodes;

    public int children;

    public int maxWeight;

    public double mutationChance;

    public double mutationFactor;

    public int areaOrIterations;

    public double averageInitialRegretTime;

    public double averageInitialRegret;

    public double averageFinalRegret;

    public double averageImprovement;

    public double averageLocalSearchTime;

    public double averageTotalTime;

    public double averageSlowdown;

    public int getNodes() {
        return nodes;
    }

    public void setNodes(int nodes) {
        this.nodes = nodes;
    }

    public int getChildren() {
        return children;
    }

    public void setChildren(int children) {
        this.children = children;
    }

    public int getMaxWeight() {
        return maxWeight;
    }

    public void setMaxWeight(int maxWeight) {
        this.maxWeight = maxWeight;
    }

    public double getMutationChance() {
        return mutationChance;
    }

    public void setMutationChance(double mutationChance) {
        this.mutationChance = mutationChance;
    }

    public double getMutationFactor() {
        return mutationFactor;
    }

    public void setMutationFactor(double mutationFactor) {
        this.mutationFactor = mutationFactor;
    }

    public int getAreaOrIterations() {
        return areaOrIterations;
    }

    public void setAreaOrIterations(int areaOrIterations) {
        this.areaOrIterations = areaOrIterations;
    }

    public double getAverageInitialRegret() {
        return averageInitialRegret;
    }

    public void setAverageInitialRegret(double averageInitialRegret) {
        this.averageInitialRegret = averageInitialRegret;
    }

    public double getAverageInitialRegretTime() {
        return averageInitialRegretTime;
    }

    public void setAverageInitialRegretTime(double averageInitialRegretTime) {
        this.averageInitialRegretTime = averageInitialRegretTime;
    }

    public double getAverageFinalRegret() {
        return averageFinalRegret;
    }

    public void setAverageFinalRegret(double averageFinalRegret) {
        this.averageFinalRegret = averageFinalRegret;
    }

    public double getAverageImprovement() {
        return averageImprovement;
    }

    public void setAverageImprovement(double averageImprovement) {
        this.averageImprovement = averageImprovement;
    }

    public double getAverageLocalSearchTime() {
        return averageLocalSearchTime;
    }

    public void setAverageLocalSearchTime(double averageLocalSearchTime) {
        this.averageLocalSearchTime = averageLocalSearchTime;
    }

    public double getAverageTotalTime() {
        return averageTotalTime;
    }

    public void setAverageTotalTime(double averageTotalTime) {
        this.averageTotalTime = averageTotalTime;
    }

    public double getAverageSlowdown() {
        return averageSlowdown;
    }

    public void setAverageSlowdown(double averageSlowdown) {
        this.averageSlowdown = averageSlowdown;
    }
}
