package hr.pmf.aklobucar.extended.scenariosolver;

import java.util.Arrays;
import java.util.stream.Collectors;
import java.util.stream.Stream;

public class ScenarioSolution {


    public  ScenarioSolution() {

    }

    public static String getHeaders() {
        return String.join(",", Arrays.asList(
                "Index",
                "Nodes",
                "Children",
                "Maximum weight",
                "Mutation chance",
                "Mutation factor",
                "Initial regret",
                "Final regret",
                "Improvement (%)",
                "Total time (µs)"
                )) + "\n";
    }

    public String getCsv() {
        return Stream.of(
                this.index,
                this.nodes,
                this.children,
                this.maxWeight,
                this.mutationChance,
                this.mutationFactor,
                this.initialRegret,
                this.finalRegret,
                this.improvement,
                this.totalTime).map(item -> item + "").collect(Collectors.joining(",")) + "\n";
    }

    public ScenarioSolution(String index, int nodes, int children, int maxWeight, double mutationChance, double mutationFactor, int area,
                            long initialRegretTime,
                            double initialRegret, double finalRegret, double improvement, double averageLocalSearchTime, long totalTime) {
        this.index = index;
        this.nodes = nodes;
        this.children = children;
        this.maxWeight = maxWeight;
        this.mutationChance = mutationChance;
        this.mutationFactor = mutationFactor;
        this.area = area;
        this.initialRegretTime = initialRegretTime;
        this.initialRegret = initialRegret;
        this.finalRegret = finalRegret;
        this.improvement = improvement;
        this.averageLocalSearchTime = averageLocalSearchTime;
        this.totalTime = totalTime;
    }

    public String index;

    public int nodes;

    public int children;

    public int maxWeight;

    public double mutationChance;

    public double mutationFactor;

    public int area;

    public long initialRegretTime;

    public double initialRegret;

    public double finalRegret;

    public double improvement;

    public double averageLocalSearchTime;

    public long totalTime;

    public int getNodes() {
        return nodes;
    }

    public void setNodes(int nodes) {
        this.nodes = nodes;
    }

    public int getChildren() {
        return children;
    }

    public void setChildren(int children) {
        this.children = children;
    }

    public int getMaxWeight() {
        return maxWeight;
    }

    public void setMaxWeight(int maxWeight) {
        this.maxWeight = maxWeight;
    }

    public double getMutationChance() {
        return mutationChance;
    }

    public void setMutationChance(double mutationChance) {
        this.mutationChance = mutationChance;
    }

    public double getMutationFactor() {
        return mutationFactor;
    }

    public void setMutationFactor(double mutationFactor) {
        this.mutationFactor = mutationFactor;
    }

    public int getArea() {
        return area;
    }

    public void setArea(int area) {
        this.area = area;
    }

    public long getInitialRegretTime() {
        return initialRegretTime;
    }

    public void setInitialRegretTime(long initialRegretTime) {
        this.initialRegretTime = initialRegretTime;
    }

    public double getInitialRegret() {
        return initialRegret;
    }

    public void setInitialRegret(double initialRegret) {
        this.initialRegret = initialRegret;
    }

    public double getFinalRegret() {
        return finalRegret;
    }

    public void setFinalRegret(double finalRegret) {
        this.finalRegret = finalRegret;
    }

    public double getImprovement() {
        return improvement;
    }

    public void setImprovement(double improvement) {
        this.improvement = improvement;
    }

    public double getAverageLocalSearchTime() {
        return averageLocalSearchTime;
    }

    public void setAverageLocalSearchTime(double averageLocalSearchTime) {
        this.averageLocalSearchTime = averageLocalSearchTime;
    }

    public long getTotalTime() {
        return totalTime;
    }

    public void setTotalTime(long totalTime) {
        this.totalTime = totalTime;
    }
}
